/* *******************************************************************
   EEPROM and Datamanagement
   ***************************************************************** */

// Writes an 2byte Integer to the given address
void EEPROMWriteinteger(int address, int myInteger)
{
    EEPROM.write(address,highByte(myInteger));
    EEPROM.write(address+1,lowByte(myInteger));
    EEPROM.commit();
}


// Reads an Integer from the given address
int EEPROMReadinteger(int address)
{
  byte high = EEPROM.read(address);
  byte low = EEPROM.read(address+1);
  int myInteger=word(high,low);
  return myInteger;
}


//This function will write a 4 byte (32bit) unsigned long to the eeprom at
//the specified address to address + 3.
//http://playground.arduino.cc/Code/EEPROMReadWriteLong
void EEPROMWritelong(int address, uint32_t value)
      {
      //Decomposition from a long to 4 bytes by using bitshift.
      //One = Most significant -> Four = Least significant byte
      byte four = (value & 0xFF);
      byte three = ((value >> 8) & 0xFF);
      byte two = ((value >> 16) & 0xFF);
      byte one = ((value >> 24) & 0xFF);

      //Write the 4 bytes into the eeprom memory.
      EEPROM.write(address, four);
      EEPROM.write(address + 1, three);
      EEPROM.write(address + 2, two);
      EEPROM.write(address + 3, one);
      EEPROM.commit();
      }


uint32_t EEPROMReadlong(int address)
      {
      //Read the 4 bytes from the eeprom memory.
      uint32_t four =  EEPROM.read(address);
      uint32_t three = EEPROM.read(address + 1);
      uint32_t two = EEPROM.read(address + 2);
      uint32_t one = EEPROM.read(address + 3);
      //Return the recomposed long by using bitshift.
      return ((four << 0) & 0xFF) + ((three << 8) & 0xFFFF) + ((two << 16) & 0xFFFFFF) + ((one << 24) & 0xFFFFFFFF);
      }

//Write 8 bytes to a given adress
void EEPROMWritestring(int address, String myString)
{
      myString = myString.substring(0, 8);
      for (uint8_t i = 0; i<8; i++)
      {
          EEPROM.write(address+i,myString.charAt(i));
      }
      EEPROM.commit();
}


//Read 8 bytes from a given adress and return a String
String EEPROMReadstring(int address)
{
                     //12345678
      char myResult[]="        ";
      for (uint8_t i = 0; i<8; i++)
      {
        myResult[i]=EEPROM.read(address+i);
      } 
      return myResult;
}
